Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/DataTypes.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/DataTypes.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/DataTypes.cs	(revision 15032)
@@ -3,5 +3,5 @@
 
   [Flags]
-  public enum DataTypes : ushort {
+  public enum DataTypes {
     None = 0x01, // Required to specify expression dependencies
     Integer = 0x02,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NumberIo.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NumberIo.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/NumberIo.cs	(revision 15032)
@@ -24,8 +24,8 @@
         WorstResult = 400,
         InputArgumentTypes = new[] { ExampleArgumentType.Float, ExampleArgumentType.Integer },
-        OutputArgumentTypes = new[] { ExampleArgumentType.Print },
+        OutputArgumentTypes = new[] { ExampleArgumentType.Float },
         TrainingCount = 25,
         TestCount = 1000,
-        EnabledDataTypes = DataTypes.Integer | DataTypes.Float | DataTypes.Print,
+        EnabledDataTypes = DataTypes.Integer | DataTypes.Float, // | DataTypes.Print,
         EvalLimit = 200,
         MaxSize = 200,
@@ -47,6 +47,6 @@
         InputFloat = ExampleArgumentConverter.ConvertDoubles(input[0]),
         InputInteger = ExampleArgumentConverter.ConvertIntegers(input[1]),
-        //OutputFloat = new[] { estimedFloatValue },
-        OutputPrint = estimedFloatValue.ToString("R", CultureInfo.InvariantCulture),
+        OutputFloat = ExampleArgumentConverter.ConvertDoubles(output),
+        //OutputPrint = estimedFloatValue.ToString("R", CultureInfo.InvariantCulture),
       };
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/DataEditorView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/DataEditorView.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/DataEditorView.cs	(revision 15032)
@@ -188,5 +188,5 @@
           var type = Content.InputArgumentTypes[i];
           var offset = inputArgumentCountDict[type];
-          row.Cells[i].Value = ViewHelper.StringifyInput(type, offset, example, ValueSeparator);
+          row.Cells[i].Value = ViewHelper.StringifyInput(type, offset, "R", example, ValueSeparator);
           inputArgumentCountDict[type]++;
         }
@@ -196,5 +196,5 @@
           var type = Content.OutputArgumentTypes[i];
           var offset = outputArgumentCountDict[type];
-          row.Cells[Content.InputArgumentTypes.Length + i].Value = ViewHelper.StringifyOutput(type, offset, example, ValueSeparator);
+          row.Cells[Content.InputArgumentTypes.Length + i].Value = ViewHelper.StringifyOutput(type, offset, "R", example, ValueSeparator);
           outputArgumentCountDict[type]++;
         }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/ViewHelper.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/ViewHelper.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/ViewHelper.cs	(revision 15032)
@@ -6,11 +6,11 @@
 
   public static class ViewHelper {
-    public static string StringifyInput(ExampleArgumentType type, int offset, Example example, string valueSeparator) {
+    public static string StringifyInput(ExampleArgumentType type, int offset, string floatFormat, Example example, string valueSeparator) {
       switch (type) {
         case ExampleArgumentType.Integer: return example.InputInteger[offset].ToString();
         case ExampleArgumentType.IntegerVector: return "[" + string.Join(", ", example.InputIntegerVector[offset]) + "]";
 
-        case ExampleArgumentType.Float: return example.InputFloat[offset].ToString(CultureInfo.CurrentUICulture);
-        case ExampleArgumentType.FloatVector: return "[" + string.Join(", ", example.InputFloatVector[offset]) + "]";
+        case ExampleArgumentType.Float: return example.InputFloat[offset].ToString(floatFormat, CultureInfo.CurrentUICulture);
+        case ExampleArgumentType.FloatVector: return "[" + string.Join(", ", example.InputFloatVector[offset].Select(x => x.ToString(floatFormat, CultureInfo.InvariantCulture))) + "]";
 
         case ExampleArgumentType.Boolean: return example.InputBoolean[offset].ToString();
@@ -24,11 +24,11 @@
     }
 
-    public static string StringifyOutput(ExampleArgumentType type, int offset, Example example, string valueSeparator) {
+    public static string StringifyOutput(ExampleArgumentType type, int offset, string floatFormat, Example example, string valueSeparator) {
       switch (type) {
         case ExampleArgumentType.Integer: return example.OutputInteger[offset].ToString();
         case ExampleArgumentType.IntegerVector: return "[" + string.Join(", ", example.OutputIntegerVector[offset]) + "]";
 
-        case ExampleArgumentType.Float: return example.OutputFloat[offset].ToString(CultureInfo.CurrentUICulture);
-        case ExampleArgumentType.FloatVector: return "[" + string.Join(", ", example.OutputFloatVector[offset]) + "]";
+        case ExampleArgumentType.Float: return example.OutputFloat[offset].ToString(floatFormat, CultureInfo.InvariantCulture);
+        case ExampleArgumentType.FloatVector: return "[" + string.Join(", ", example.OutputFloatVector[offset].Select(x => x.ToString(floatFormat, CultureInfo.InvariantCulture))) + "]";
 
         case ExampleArgumentType.Boolean: return example.OutputBoolean[offset].ToString();
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Boolean/BooleanRandomErc.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Boolean/BooleanRandomErc.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Boolean/BooleanRandomErc.cs	(revision 15032)
@@ -14,5 +14,5 @@
     private const string AllowFalseParameterName = "Allow false";
 
-    public BooleanRandomErc() : this(false, true, true) { }
+    public BooleanRandomErc() : this(true, true, true) { }
 
     public BooleanRandomErc(bool isEnabled, bool allowTrue, bool allowFalse, double weight = 1d) : base(isEnabled, weight) {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Float/FloatConstantErc.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Float/FloatConstantErc.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Float/FloatConstantErc.cs	(revision 15032)
@@ -7,5 +7,5 @@
   public class FloatConstantErc : ConstantsWeightedErc<double, DoubleArray> {
 
-    public FloatConstantErc() : this(false, 1d) { }
+    public FloatConstantErc() : this(true, 1d) { }
 
     public FloatConstantErc(params double[] constants) : this(true, 1d, constants) { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Float/FloatRangeErc.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Float/FloatRangeErc.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Float/FloatRangeErc.cs	(revision 15032)
@@ -10,5 +10,5 @@
     private const string RangeParameterName = "Range";
 
-    public FloatRangeErc() : this(false, 0d, 0d) { }
+    public FloatRangeErc() : this(true, 0d, 0d) { }
 
     public FloatRangeErc(double start, double end) : this(true, start, end) { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Integer/IntegerConstantErc.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Integer/IntegerConstantErc.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Integer/IntegerConstantErc.cs	(revision 15032)
@@ -7,5 +7,5 @@
   public class IntegerConstantErc : ConstantsWeightedErc<int, IntArray> {
 
-    public IntegerConstantErc() : this(false, 1d) { }
+    public IntegerConstantErc() : this(true, 1d) { }
 
     public IntegerConstantErc(params int[] constants) : this(true, 1d, constants) { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Integer/IntegerRangeErc.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Integer/IntegerRangeErc.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Integer/IntegerRangeErc.cs	(revision 15032)
@@ -10,5 +10,5 @@
     private const string RangeParameterName = "Range";
 
-    public IntegerRangeErc() : this(false, 0, 0) { }
+    public IntegerRangeErc() : this(true, 0, 0) { }
 
     public IntegerRangeErc(int start, int end) : this(true, start, end) { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/String/StringConstantErc.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/String/StringConstantErc.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/String/StringConstantErc.cs	(revision 15032)
@@ -12,5 +12,5 @@
     private const string ConstantsParameterName = "Constants";
 
-    public StringConstantErc() : this(false, 1d) { }
+    public StringConstantErc() : this(true, 1d) { }
 
     public StringConstantErc(params string[] constants) : this(true, 1d, constants) { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/String/StringRandomErc.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/String/StringRandomErc.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/String/StringRandomErc.cs	(revision 15032)
@@ -27,5 +27,5 @@
     private const string NewStringProbabilityParameterDescription = "The probability that the selection of the ephemeral random string constant for inclusion in randomly generated code will produce a new string (rather than a string that was previously generated).";
 
-    public StringRandomErc() : this(false, 1d) { }
+    public StringRandomErc() : this(true, 1d) { }
 
     public StringRandomErc(bool isEnabled, double weight = 1d) : base(isEnabled, weight) {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/StringVector/StringVectorConstantsErc.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/StringVector/StringVectorConstantsErc.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/StringVector/StringVectorConstantsErc.cs	(revision 15032)
@@ -15,5 +15,5 @@
     private const string ConstantsParameterName = "Constants";
 
-    public StringVectorConstantsErc() : this(false, 1d) { }
+    public StringVectorConstantsErc() : this(true, 1d) { }
     public StringVectorConstantsErc(params string[][] arrays) : this(true, 1d, arrays.Select(x => new StringArray(x)).ToArray()) { }
     public StringVectorConstantsErc(params StringArray[] arrays) : this(true, 1d, arrays) { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Views/ErcOptionsView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Views/ErcOptionsView.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Views/ErcOptionsView.cs	(revision 15032)
@@ -32,5 +32,6 @@
       double value;
       if (double.TryParse(text, out value)) {
-        possibilityTextBox.Text = (value / 100.0).ToString(PERCENTAGE_FORMAT);
+        if (value > 1) value /= 100.0;
+        possibilityTextBox.Text = value.ToString(PERCENTAGE_FORMAT);
       } else {
         possibilityTextBox.Text = "0%";
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 15032)
@@ -36,4 +36,8 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HeuristicLab.Analysis-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Analysis-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Collections-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
@@ -118,4 +122,6 @@
       <DependentUpon>Resources.resx</DependentUpon>
     </Compile>
+    <Compile Include="Push\Analyzer\IPushExpressionAnalyzer.cs" />
+    <Compile Include="Push\Analyzer\PushExpressionFrequencyAnalyzer.cs" />
     <Compile Include="Push\Attributes\PushExpressionAttriubte.cs" />
     <Compile Include="Push\Attributes\PushStackAttribute.cs" />
@@ -187,4 +193,5 @@
     <Compile Include="Push\Extensions\CollectionExtensions.cs" />
     <Compile Include="Push\Extensions\ControlExntensions.cs" />
+    <Compile Include="Push\Extensions\EnumExtensions.cs" />
     <Compile Include="Push\Extensions\LongExtensions.cs" />
     <Compile Include="Push\Extensions\RandomExtensions.cs" />
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Attributes/PushExpressionAttriubte.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Attributes/PushExpressionAttriubte.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Attributes/PushExpressionAttriubte.cs	(revision 15032)
@@ -8,10 +8,19 @@
     public readonly StackTypes StackType;
     public readonly StackTypes AdditionalStackDependencies;
-    public readonly string ExpressionName;
+    public readonly string Name;
+    public readonly string Description;
+
+    /// <summary>
+    /// Determines if this expression manipulates the exec stack.
+    /// </summary>
     public readonly bool ManipulatesExec;
+
+    /// <summary>
+    /// Determines the amount of items fetched form the EXEC stack required for this expression. Used for mapping individuals.
+    /// </summary>
     public readonly uint ExecIn;
 
     /// <summary>
-    /// Determines if the expression is visible to the user during the configuration phase for example.
+    /// Determines if the expression is visible to the user for configuration purposes.
     /// </summary>
     public readonly bool IsHidden;
@@ -19,11 +28,14 @@
     public PushExpressionAttribute(
       StackTypes stackType,
-      string expressionName,
+      string name,
+      string description,
       StackTypes additionalStackDependencies = default(StackTypes),
       uint execIn = 0,
       bool isHidden = false) {
+
       StackType = stackType;
       AdditionalStackDependencies = additionalStackDependencies;
-      ExpressionName = expressionName;
+      Name = name;
+      Description = description;
       ExecIn = execIn;
       IsHidden = isHidden;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IEnabledExpressionsConfiguration.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IEnabledExpressionsConfiguration.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IEnabledExpressionsConfiguration.cs	(revision 15032)
@@ -20,17 +20,17 @@
     event EventHandler<EnabledExpressionsChangedEventArgs> EnabledExpressionsChanged;
 
-    IList<string> EnabledExpressions { get; }
+    IReadOnlyList<string> EnabledExpressions { get; }
 
-    void EnableStack(StackTypes types, bool enableExpressions = true, bool enableDependencies = true);
-    void DisableStack(StackTypes type, bool disableExpressions = true, bool enableDepenencies = true);
-    void SetStack(StackTypes type, bool state, bool setExpressions = true, bool setDependencies = true);
+    void EnableStack(StackTypes types, bool enableDependencies = false);
+    void DisableStack(StackTypes type, bool enableDepenencies = false);
+    void SetStack(StackTypes type, bool state, bool setDependencies = false);
     void EnableExpressionOfStack(StackTypes types);
     void DisableExpressionsOfStack(StackTypes types);
-    void EnableExpression(string name, bool enableStackIfDisabled = false);
-    void DisableExpression(string name, bool disableStackIfEnabled = false);
-    void SetExpression(string name, bool state, bool cascadeForStack = false);
-    void SetExpression<T>(bool state, bool cascadeForStack = false) where T : Expression;
-    void EnableExpression<T>(bool enableStackIfDisabled = false) where T : Expression;
-    void DisableExpression<T>(bool disableStackIfEnabled = false) where T : Expression;
+    void EnableExpression(string name);
+    void DisableExpression(string name);
+    void SetExpression(string name, bool state);
+    void SetExpression<T>(bool state) where T : Expression;
+    void EnableExpression<T>() where T : Expression;
+    void DisableExpression<T>() where T : Expression;
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 15032)
@@ -3,8 +3,10 @@
   using Base.Erc;
   using Common;
+
+  using HeuristicLab.Core;
+
   using Stack;
 
-  public interface IReadOnlyPushConfiguration : IDeepCloneable {
-    IReadOnlyDictionary<StackTypes, bool> EnabledStacks { get; }
+  public interface IReadOnlyPushConfiguration : IItem {
     int EvalPushLimit { get; }
     int MaxDepth { get; }
@@ -20,4 +22,6 @@
     IReadOnlyList<string> EnabledExpressions { get; }
     string FloatStringFormat { get; }
+
+    bool IsStackEnabled(StackTypes stackType);
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs	(revision 15032)
@@ -1,20 +1,12 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Configuration {
-  using System;
   using System.Collections.Generic;
-  using System.Linq;
   using Base.Erc;
   using Common;
-  using Core;
-  using Expressions;
   using Persistence.Default.CompositeSerializers.Storable;
-  using Stack;
 
   [StorableClass]
-  public class PushConfiguration : ParameterizedNamedItem, IReadOnlyPushConfiguration, IEnabledExpressionsConfiguration {
+  public class PushConfiguration : PushConfigurationBase, IReadOnlyPushConfiguration {
     public PushConfiguration() {
       Name = "Push Configuration";
-
-      enabledExpressions = ExpressionTable.ExpressionNames.ToList();
-      enabledStacks = new Dictionary<StackTypes, bool>();
 
       ErcOptions = new ErcOptions();
@@ -31,14 +23,6 @@
       MaxParenthesesClose = 4;
       ParenthesesCloseBiasLevel = 1;
-
-      InitEnabledStacks();
     }
 
-    private void InitEnabledStacks(bool state = true) {
-      foreach (StackTypes type in Enum.GetValues(typeof(StackTypes))) {
-        if (!enabledStacks.ContainsKey(type) && type != StackTypes.None)
-          enabledStacks.Add(type, state);
-      }
-    }
 
     [StorableConstructor]
@@ -48,6 +32,4 @@
 
     public PushConfiguration(PushConfiguration origin, Cloner cloner) : base(origin, cloner) {
-      enabledExpressions = origin.EnabledExpressions.ToList();
-      enabledStacks = origin.EnabledStacks.ToDictionary(x => x.Key, x => x.Value);
 
       ErcOptions = cloner.Clone(origin.ErcOptions);
@@ -66,38 +48,8 @@
     }
 
-    [StorableHook(HookType.AfterDeserialization)]
-    // ReSharper disable once UnusedMember.Local
-    private void AfterDeserialization() {
-      // Ensures that all types added after last serialization are available in enabledStacks
-      InitEnabledStacks(false);
-    }
-
     [Storable]
     public string FloatStringFormat { get; set; }
 
-    [Storable]
-    private readonly Dictionary<StackTypes, bool> enabledStacks;
 
-    public IReadOnlyDictionary<StackTypes, bool> EnabledStacks { get { return enabledStacks; } }
-
-    public event EventHandler<EnabledExpressionsChangedEventArgs> EnabledExpressionsChanged;
-
-    [Storable]
-    private readonly List<string> enabledExpressions;
-
-    public IList<string> EnabledExpressions
-    {
-      get { return enabledExpressions; }
-      set
-      {
-        var removedExpressions = enabledExpressions.ToArray();
-        enabledExpressions.Clear();
-        enabledExpressions.AddRange(value);
-
-        if (EnabledExpressionsChanged != null) {
-          EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(value, removedExpressions));
-        }
-      }
-    }
     IReadOnlyList<string> IReadOnlyPushConfiguration.EnabledExpressions { get { return enabledExpressions; } }
 
@@ -174,146 +126,4 @@
     public int MaxVectorLength { get; set; }
 
-
-    public void SetEnabledStacks(StackTypes types) {
-      // Disable all
-      EnabledExpressions.Clear();
-
-      foreach (StackTypes type in Enum.GetValues(types.GetType())) {
-        if (type == StackTypes.None) continue;
-        enabledStacks[type] = false;
-      }
-
-      foreach (var pair in ExpressionTable.StackDependencyToNamesTable) {
-        if (types.HasFlag(pair.Key)) {
-          foreach (var name in pair.Value) {
-            EnableExpression(name, true);
-          }
-        }
-      }
-    }
-
-    public void EnableExpressionOfStack(StackTypes types) {
-      EnableExpressions(ExpressionTable.StackTypeToNamesTable[types]);
-    }
-
-    public void EnableExpressionDependentOnStack(StackTypes types) {
-      var names = ExpressionTable.StackDependencyToNamesTable[types].Where(
-        name => {
-          var type = ExpressionTable.NameToTypeTable[name];
-          var attribute = ExpressionTable.TypeToAttributeTable[type];
-
-          return (attribute.StackType | attribute.AdditionalStackDependencies)
-            .ToEnumerable()
-            .All(st => enabledStacks.ContainsKey(st) && enabledStacks[st]);
-        });
-
-      EnableExpressions(names);
-    }
-
-    private void EnableExpressions(IEnumerable<string> names) {
-      foreach (var name in names.Except(EnabledExpressions))
-        EnabledExpressions.Add(name);
-
-      if (EnabledExpressionsChanged != null) {
-        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(names, new string[0]));
-      }
-    }
-
-    public void DisableExpressionsOfStack(StackTypes types) {
-      DisableExpressions(ExpressionTable.StackTypeToNamesTable[types]);
-    }
-
-    public void DisableExpressionsDependentOnStack(StackTypes types) {
-      var names = ExpressionTable.StackDependencyToNamesTable
-          .Where(pair => pair.Key.HasFlag(types))
-          .SelectMany(pair => pair.Value);
-
-      DisableExpressions(names);
-    }
-
-    private void DisableExpressions(IEnumerable<string> names) {
-      foreach (var name in names.Intersect(EnabledExpressions))
-        EnabledExpressions.Remove(name);
-
-      if (EnabledExpressionsChanged != null) {
-        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(new string[0], names));
-      }
-    }
-
-    public void EnableExpression(string name, bool enableStackIfDisabled = false) {
-      if (EnabledExpressions.Contains(name)) return;
-
-      EnabledExpressions.Add(name);
-
-      if (enableStackIfDisabled) {
-        var type = ExpressionTable.TypeToNameTable.Single(x => x.Value == name).Key;
-        var attribute = ExpressionTable.TypeToAttributeTable[type];
-        enabledStacks[attribute.StackType] = true;
-      }
-
-      if (EnabledExpressionsChanged != null) {
-        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(
-          new[] { name },
-          new string[0]));
-      }
-    }
-
-    public void DisableExpression(string name, bool disableStackIfEnabled = false) {
-      if (!EnabledExpressions.Contains(name)) return;
-
-      EnabledExpressions.Remove(name);
-
-      if (disableStackIfEnabled) {
-        var type = ExpressionTable.TypeToNameTable.Single(x => x.Value == name).Key;
-        var attribute = ExpressionTable.TypeToAttributeTable[type];
-        enabledStacks[attribute.StackType] = false;
-      }
-
-      if (EnabledExpressionsChanged != null) {
-        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(
-          new string[0],
-          new[] { name }));
-      }
-    }
-
-    public void EnableExpression<T>(bool enableStackIfDisabled = false) where T : Expression {
-      var attribute = ExpressionTable.TypeToAttributeTable[typeof(T)];
-      EnableExpression(attribute.ExpressionName, enableStackIfDisabled);
-    }
-
-    public void DisableExpression<T>(bool disableStackIfEnabled = false) where T : Expression {
-      var attribute = ExpressionTable.TypeToAttributeTable[typeof(T)];
-      DisableExpression(attribute.ExpressionName, disableStackIfEnabled);
-    }
-
-    public void SetExpression(string name, bool state, bool cascadeForStack = false) {
-      if (state) EnableExpression(name, cascadeForStack);
-      else DisableExpression(name, cascadeForStack);
-    }
-
-    public void SetExpression<T>(bool state, bool cascadeForStack = false) where T : Expression {
-      if (state) EnableExpression<T>(cascadeForStack);
-      else DisableExpression<T>(cascadeForStack);
-    }
-
-    public void EnableStack(StackTypes type, bool enableExpressions = true, bool enableDependencies = true) {
-      enabledStacks[type] = true;
-
-      if (enableExpressions) EnableExpressionOfStack(type);
-      if (enableDependencies) EnableExpressionDependentOnStack(type);
-    }
-
-    public void DisableStack(StackTypes type, bool disableExpressions = true, bool disableDependencies = true) {
-      enabledStacks[type] = false;
-
-      if (disableExpressions) DisableExpressionsOfStack(type);
-      if (disableDependencies) DisableExpressionsDependentOnStack(type);
-    }
-
-    public void SetStack(StackTypes type, bool state, bool setExpressions = true, bool setDependencies = true) {
-      if (state) EnableStack(type, setExpressions, setDependencies);
-      else DisableStack(type, setExpressions, setDependencies);
-    }
-
     public override IDeepCloneable Clone(Cloner cloner) {
       return new PushConfiguration(this, cloner);
